<?php
/**
 * ARTIO VM SMS
 *
 * @package   ARTIO VM SMS
 * @version   1.0.4
 * @author    ARTIO http://www.artio.net
 * @copyright Copyright (C) 2015 ARTIO s.r.o.
 * @license   GNU/GPLv3 http://www.artio.net/license/gnu-general-public-license
 */

// no direct access
defined('_JEXEC') or die;

class VmsmsViewDashboard extends VmsmsView
{
    public function display($tpl = null)
    {
        // Toolbar
        JToolBarHelper::title(JText::_('COM_VMSMS_DASHBOARD_TITLE'), 'vmsms.png');
        
        $lists = $this->get('Lists');
        $creditInfo = $this->get('CreditInfo');
        $info = $this->get('ComponentInfo');
        $newVersion = $this->get('NewVersion');
        
        if (version_compare($newVersion, $info['version'], '>')) {
            $newVersion = '<span style="font-weight: bold; color: red;">'.$newVersion.'</span>';
        }
        
        $this->assign('newVersion', $newVersion);
        $this->assignRef('lists', $lists);
        $this->assignRef('creditInfo', $creditInfo);
        $this->assignRef('info', $info);
        
        parent::display($tpl);
    }
}
